import { LanguageCode } from '@widget-js/core';

interface Pageable {
    page: number;
    pageSize: number;
}
interface Pagination<T> {
    total: number;
    page: number;
    totalPage: number;
    pageSize: number;
    data: T[];
}

interface WidgetSearchOptions extends Pageable {
    keyword: string;
    language?: LanguageCode;
    packageKeyword?: string;
    checkMicrosoftStoreReview?: boolean;
}

interface IResponse<T = any> {
    code: number;
    msg: string;
    data?: T;
}
type FailResponse = Omit<IResponse, 'data'>;
declare class R {
    static ok<T = any>(data?: T): IResponse<T>;
    static fail(fail: string | FailResponse): IResponse;
}

export { IResponse, Pageable, Pagination, R, WidgetSearchOptions };
